Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views-3.3.csproj
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views-3.3.csproj	(revision 9723)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views-3.3.csproj	(revision 9728)
@@ -143,4 +143,10 @@
       <DependentUpon>ParameterInfluenceView.cs</DependentUpon>
     </Compile>
+    <Compile Include="PermutationSolutionDictionaryView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="PermutationSolutionDictionaryView.Designer.cs">
+      <DependentUpon>PermutationSolutionDictionaryView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/PermutationSolutionDictionaryView.Designer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/PermutationSolutionDictionaryView.Designer.cs	(revision 9728)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/PermutationSolutionDictionaryView.Designer.cs	(revision 9728)
@@ -0,0 +1,117 @@
+﻿namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views {
+  partial class PermutationSolutionDictionaryView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.label1 = new System.Windows.Forms.Label();
+      this.label2 = new System.Windows.Forms.Label();
+      this.label3 = new System.Windows.Forms.Label();
+      this.cacheSizeTextBox = new System.Windows.Forms.TextBox();
+      this.partialSizeTextBox = new System.Windows.Forms.TextBox();
+      this.completeSizeTextBox = new System.Windows.Forms.TextBox();
+      this.SuspendLayout();
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(3, 10);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(64, 13);
+      this.label1.TabIndex = 0;
+      this.label1.Text = "Cache Size:";
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(3, 42);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(108, 13);
+      this.label2.TabIndex = 1;
+      this.label2.Text = "Partial Solutions Size:";
+      // 
+      // label3
+      // 
+      this.label3.AutoSize = true;
+      this.label3.Location = new System.Drawing.Point(3, 74);
+      this.label3.Name = "label3";
+      this.label3.Size = new System.Drawing.Size(123, 13);
+      this.label3.TabIndex = 2;
+      this.label3.Text = "Complete Solutions Size:";
+      // 
+      // cacheSizeTextBox
+      // 
+      this.cacheSizeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.cacheSizeTextBox.Location = new System.Drawing.Point(132, 7);
+      this.cacheSizeTextBox.Name = "cacheSizeTextBox";
+      this.cacheSizeTextBox.ReadOnly = true;
+      this.cacheSizeTextBox.Size = new System.Drawing.Size(351, 20);
+      this.cacheSizeTextBox.TabIndex = 3;
+      // 
+      // partialSizeTextBox
+      // 
+      this.partialSizeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.partialSizeTextBox.Location = new System.Drawing.Point(132, 39);
+      this.partialSizeTextBox.Name = "partialSizeTextBox";
+      this.partialSizeTextBox.ReadOnly = true;
+      this.partialSizeTextBox.Size = new System.Drawing.Size(351, 20);
+      this.partialSizeTextBox.TabIndex = 4;
+      // 
+      // completeSizeTextBox
+      // 
+      this.completeSizeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.completeSizeTextBox.Location = new System.Drawing.Point(132, 71);
+      this.completeSizeTextBox.Name = "completeSizeTextBox";
+      this.completeSizeTextBox.ReadOnly = true;
+      this.completeSizeTextBox.Size = new System.Drawing.Size(351, 20);
+      this.completeSizeTextBox.TabIndex = 5;
+      // 
+      // PermutationSolutionDictionaryView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.completeSizeTextBox);
+      this.Controls.Add(this.partialSizeTextBox);
+      this.Controls.Add(this.cacheSizeTextBox);
+      this.Controls.Add(this.label3);
+      this.Controls.Add(this.label2);
+      this.Controls.Add(this.label1);
+      this.Name = "PermutationSolutionDictionaryView";
+      this.Size = new System.Drawing.Size(486, 98);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.Label label3;
+    private System.Windows.Forms.TextBox cacheSizeTextBox;
+    private System.Windows.Forms.TextBox partialSizeTextBox;
+    private System.Windows.Forms.TextBox completeSizeTextBox;
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/PermutationSolutionDictionaryView.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/PermutationSolutionDictionaryView.cs	(revision 9728)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/PermutationSolutionDictionaryView.cs	(revision 9728)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views {
+  [View("PermutationSolutionDictionary View")]
+  [Content(typeof(PermutationSolutionDictionary<PermutationWrapper, PermutationInformation>), true)]
+  public partial class PermutationSolutionDictionaryView : ItemView {
+    public PermutationSolutionDictionaryView() {
+      InitializeComponent();
+    }
+
+    public new PermutationSolutionDictionary<PermutationWrapper, PermutationInformation> Content {
+      get { return (PermutationSolutionDictionary<PermutationWrapper, PermutationInformation>)base.Content; }
+      set { base.Content = value; }
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      cacheSizeTextBox.Clear();
+      partialSizeTextBox.Clear();
+      completeSizeTextBox.Clear();
+
+      if (Content != null) {
+        cacheSizeTextBox.Text = Content.Size().ToString();
+        partialSizeTextBox.Text = Content.NumberOfPartialSolutions().ToString();
+        completeSizeTextBox.Text = Content.NumberOfCompleteSolutions().ToString();
+      }
+    }                                                                             
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 9723)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 9728)
@@ -119,4 +119,5 @@
     <Compile Include="SolutionsCaching\SolutionDictionary.cs" />
     <Compile Include="SelectionPressureAnalyzer.cs" />
+    <Compile Include="SolutionsCaching\PermutationInformation.cs" />
     <Compile Include="WorstQualityAnalyzer.cs" />
     <Compile Include="InitializableOperator.cs" />
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/PermutationInformation.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/PermutationInformation.cs	(revision 9728)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/PermutationInformation.cs	(revision 9728)
@@ -0,0 +1,55 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
+  public enum ProducedBy { Crossover, Mutation };
+
+  [Item("PermutationInformation", "Stores meta-information about a solution.")]
+  [StorableClass]
+  public class PermutationInformation : Item {
+    [Storable]
+    public ProducedBy ProducedBy { get; set; }
+    [Storable]
+    public List<PermutationWrapper> ParentList { get; set; }
+    [Storable]
+    public int Generation { get; set; }
+
+    public PermutationInformation() { }
+
+    [StorableConstructor]
+    protected PermutationInformation(bool deserializing) : base(deserializing) { }
+    protected PermutationInformation(PermutationInformation original, Cloner cloner)
+      : base(original, cloner) {
+      this.ProducedBy = original.ProducedBy;
+      this.ParentList = new List<PermutationWrapper>(original.ParentList);
+      this.Generation = original.Generation;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PermutationInformation(this, cloner);
+    }
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/PermutationSolutionDictionary.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/PermutationSolutionDictionary.cs	(revision 9723)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/PermutationSolutionDictionary.cs	(revision 9728)
@@ -31,5 +31,6 @@
   [StorableClass]
   public class PermutationSolutionDictionary<TKey, TValue> : SolutionDictionary<TKey, TValue>
-    where TKey : PermutationWrapper {
+    where TKey : PermutationWrapper
+    where TValue : PermutationInformation {
 
     public PermutationSolutionDictionary() {
@@ -83,4 +84,12 @@
       return new PermutationSolutionDictionary<TKey, TValue>(this, cloner);
     }
+
+    public int NumberOfPartialSolutions() {
+      return solutionDictionary.Where(x => x.Key.ElementType == ElementType.Diff).Count();
+    }
+
+    public int NumberOfCompleteSolutions() {
+      return solutionDictionary.Where(x => x.Key.ElementType == ElementType.Complete).Count();
+    }
   }
 }
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/SolutionCachingAnalyzer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/SolutionCachingAnalyzer.cs	(revision 9723)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/SolutionCachingAnalyzer.cs	(revision 9728)
@@ -20,5 +20,4 @@
 #endregion
 
-
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -35,5 +34,5 @@
   public class SolutionCachingAnalyzer : SingleSuccessorOperator, IAnalyzer {
     private const string ResultsParameterName = "Results";
-    //TODO: this should be a stateful item!
+
     #region IAnalyzer Members
     public bool EnabledByDefault {
@@ -58,7 +57,4 @@
       get { return ResultsParameter.ActualValue; }
     }
-
-    [Storable]
-    private PermutationSolutionDictionary<PermutationWrapper, int> solDict;
     #endregion
 
@@ -68,5 +64,4 @@
     private SolutionCachingAnalyzer(SolutionCachingAnalyzer original, Cloner cloner)
       : base(original, cloner) {
-      this.solDict = (PermutationSolutionDictionary<PermutationWrapper, int>)original.solDict.Clone(cloner);
     }
 
@@ -76,5 +71,4 @@
       Parameters.Add(new LookupParameter<IntValue>("Generations", "Nr of generations."));
       Parameters.Add(new ScopeTreeLookupParameter<Permutation>("Solution", "The solutions that should be stored.", "TSPTour", 1));
-      solDict = new PermutationSolutionDictionary<PermutationWrapper, int>();
     }
 
@@ -85,13 +79,20 @@
     public override IOperation Apply() {
       ItemArray<Permutation> solutions = SolutionParameter.ActualValue;
+      PermutationSolutionDictionary<PermutationWrapper, PermutationInformation> solDict;
+
+      if (!Results.ContainsKey("SolutionCache")) {
+        solDict = new PermutationSolutionDictionary<PermutationWrapper, PermutationInformation>();
+        Results.Add(new Result("SolutionCache", solDict));
+      } else {
+        solDict = (PermutationSolutionDictionary<PermutationWrapper, PermutationInformation>)Results["SolutionCache"].Value;
+      }
 
       foreach (var sol in solutions) {
-        solDict.Add(new PermutationWrapper(sol), GenerationsParameter.ActualValue.Value);
+        PermutationInformation info = new PermutationInformation();
+        info.Generation = GenerationsParameter.ActualValue.Value;
+        info.ProducedBy = ProducedBy.Mutation;
+        
+        solDict.Add(new PermutationWrapper(sol), info);
       }
-
-      if (!ResultsParameter.ActualValue.ContainsKey("SolutionCache")) {
-        ResultsParameter.ActualValue.Add(new Result("SolutionCache", solDict));
-      }
-
       return base.Apply();
     }
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/SolutionDictionary.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/SolutionDictionary.cs	(revision 9723)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/SolutionsCaching/SolutionDictionary.cs	(revision 9728)
@@ -66,4 +66,8 @@
       return solutionDictionary.ContainsKey(key);
     }
+
+    public int Size() {
+      return solutionDictionary.Count;
+    }
   }
 }
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.sln
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.sln	(revision 9723)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.sln	(revision 9728)
@@ -5,5 +5,4 @@
 	ProjectSection(SolutionItems) = preProject
 		Build.cmd = Build.cmd
-		Performance1.psess = Performance1.psess
 		PreBuildEvent.cmd = PreBuildEvent.cmd
 	EndProjectSection